Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4541)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4542)
@@ -305,44 +304,44 @@
     PRIVATE
 
-    PUBLIC bcm_parin, &
-           bcm_check_parameters, &
-           bcm_check_data_output, &
-           bcm_check_data_output_pr, &
-           bcm_init_arrays, &
-           bcm_init, &
-           bcm_header, &
-           bcm_actions, &
-           bcm_non_advective_processes, &
-           bcm_exchange_horiz, &
-           bcm_prognostic_equations, &
-           bcm_boundary_conditions, &
-           bcm_3d_data_averaging, &
-           bcm_data_output_2d, &
-           bcm_data_output_3d, &
-           bcm_swap_timelevel, &
-           bcm_rrd_global, &
-           bcm_rrd_local, &
-           bcm_wrd_global, &
-           bcm_wrd_local, &
+    PUBLIC bcm_parin,                                                                              &
+           bcm_check_parameters,                                                                   &
+           bcm_check_data_output,                                                                  &
+           bcm_check_data_output_pr,                                                               &
+           bcm_init_arrays,                                                                        &
+           bcm_init,                                                                               &
+           bcm_header,                                                                             &
+           bcm_actions,                                                                            &
+           bcm_non_advective_processes,                                                            &
+           bcm_exchange_horiz,                                                                     &
+           bcm_prognostic_equations,                                                               &
+           bcm_boundary_conditions,                                                                &
+           bcm_3d_data_averaging,                                                                  &
+           bcm_data_output_2d,                                                                     &
+           bcm_data_output_3d,                                                                     &
+           bcm_swap_timelevel,                                                                     &
+           bcm_rrd_global,                                                                         &
+           bcm_rrd_local,                                                                          &
+           bcm_wrd_global,                                                                         &
+           bcm_wrd_local,                                                                          &
            calc_liquid_water_content
 
-    PUBLIC call_microphysics_at_all_substeps, &
-           cloud_water_sedimentation, &
-           bulk_cloud_model, &
-           cloud_scheme, &
-           collision_turbulence, &
-           dt_precipitation, &
-           microphysics_morrison, &
-           microphysics_morrison_no_rain, &
-           microphysics_sat_adjust, &
-           microphysics_seifert, &
-           microphysics_ice_phase, &
-           na_init, &
-           nc_const, &
-           precipitation, &
-           sigma_gc, &
-           start_ice_microphysics, &
-           ice_crystal_sedimentation, &
-           in_init
+    PUBLIC bulk_cloud_model,                                                                       &
+           call_microphysics_at_all_substeps,                                                      &
+           cloud_water_sedimentation,                                                              &
+           cloud_scheme,                                                                           &
+           collision_turbulence,                                                                   &
+           dt_precipitation,                                                                       &
+           ice_crystal_sedimentation,                                                              &
+           in_init,                                                                                &
+           microphysics_morrison,                                                                  &
+           microphysics_morrison_no_rain,                                                          &
+           microphysics_sat_adjust,                                                                &
+           microphysics_seifert,                                                                   &
+           microphysics_ice_phase,                                                                 &
+           na_init,                                                                                &
+           nc_const,                                                                               &
+           precipitation,                                                                          &
+           sigma_gc,                                                                               &
+           start_ice_microphysics
 
     INTERFACE bcm_parin
@@ -438,9 +437,9 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Parin for &bulk_cloud_parameters for the bulk cloud module
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
     SUBROUTINE bcm_parin
 
@@ -448,25 +447,26 @@
        IMPLICIT NONE
 
-       CHARACTER (LEN=80)  ::  line  !< dummy string that contains the current line of the parameter file
-
-       NAMELIST /bulk_cloud_parameters/  &
-          aerosol_bulk, &
-          c_sedimentation, &
-          call_microphysics_at_all_substeps, &
-          bulk_cloud_model, &
-          cloud_scheme, &
-          cloud_water_sedimentation, &
-          collision_turbulence, &
-          curvature_solution_effects_bulk, &
-          dry_aerosol_radius, &
-          limiter_sedimentation, &
-          na_init, &
-          nc_const, &
-          sigma_bulk, &
-          ventilation_effect, &
-          ice_crystal_sedimentation, &
-          microphysics_ice_phase, &
-          start_ice_microphysics, &
-          in_init
+       CHARACTER (LEN=80)  ::  line  !< dummy string that contains the current line of the parameter
+                                     !< file
+
+       NAMELIST /bulk_cloud_parameters/                                                            &
+          aerosol_bulk,                                                                            &
+          bulk_cloud_model,                                                                        &
+          c_sedimentation,                                                                         &
+          call_microphysics_at_all_substeps,                                                       &
+          cloud_scheme,                                                                            &
+          cloud_water_sedimentation,                                                               &
+          collision_turbulence,                                                                    &
+          curvature_solution_effects_bulk,                                                         &
+          dry_aerosol_radius,                                                                      &
+          ice_crystal_sedimentation,                                                               &
+          in_init,                                                                                 &
+          limiter_sedimentation,                                                                   &
+          microphysics_ice_phase,                                                                  &
+          na_init,                                                                                 &
+          nc_const,                                                                                &
+          sigma_bulk,                                                                              &
+          start_ice_microphysics,                                                                  &
+          ventilation_effect
 
        line = ' '
@@ -492,9 +492,9 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Check parameters routine for bulk cloud module
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
     SUBROUTINE bcm_check_parameters
 
@@ -503,7 +503,6 @@
 !
 !--    Check cloud scheme
-!--    This scheme considers only saturation adjustment,
-!--    i.e. water vapor surplus is converted into liquid
-!--    water. No other microphysical processes are considered
+!--    This scheme considers only saturation adjustment, i.e. water vapor surplus is converted into
+!--    liquid water. No other microphysical processes are considered.
        IF ( cloud_scheme == 'saturation_adjust' )  THEN
           microphysics_sat_adjust = .TRUE.
@@ -513,11 +512,9 @@
           microphysics_morrison_no_rain = .FALSE.
 !
-!--    This scheme includes all process of the seifert 
-!--    beheng scheme (2001,2006). Especially rain processes are 
-!--    considered with prognostic quantities of qr and nr. 
-!--    Cloud droplet concentration is assumed to be constant and 
-!--    qc is diagnostic.
-!--    Technical remark: The switch 'microphysics_seifert' allocates
-!--    fields of qr and nr and enables all rain processes.
+!--    This scheme includes all process of the seifert beheng scheme (2001,2006). Especially rain
+!--    processes are considered with prognostic quantities of qr and nr.
+!--    Cloud droplet concentration is assumed to be constant and qc is diagnostic.
+!--    Technical remark: The switch 'microphysics_seifert' allocates fields of qr and nr and enables
+!--    all rain processes.
        ELSEIF ( cloud_scheme == 'seifert_beheng' )  THEN
           microphysics_sat_adjust = .FALSE.
@@ -528,7 +525,6 @@
           microphysics_morrison_no_rain = .FALSE.
 !
-!--    The kessler scheme is a simplified scheme without any
-!--    prognostic quantities for microphyical variables but 
-!--    considering autoconversion.
+!--    The kessler scheme is a simplified scheme without any prognostic quantities for microphyical
+!--    variables but considering autoconversion.
        ELSEIF ( cloud_scheme == 'kessler' )  THEN
           microphysics_sat_adjust = .FALSE.
@@ -539,13 +535,11 @@
           microphysics_morrison_no_rain = .FALSE.
 !
-!--    The morrison scheme is an extension of the seifer beheng scheme
-!--    including also relevant processes for cloud droplet size particles
-!--    such as activation and an diagnostic mehtod for diffusional growth.
-!--    I.e. here all processes of Seifert and Beheng as well as of the 
-!--    morrision scheme are used. Therefore, ztis includes prognostic 
-!--    quantities for qc and nc.
-!--    Technical remark: The switch 'microphysics_morrison' allocates
-!--    fields of qc and nc and enables diagnostic diffusional growth and 
-!--    activation.
+!--    The morrison scheme is an extension of the seifer beheng scheme including also relevant
+!--    processes for cloud droplet size particles such as activation and an diagnostic mehtod for
+!--    diffusional growth.
+!--    I.e. here all processes of Seifert and Beheng as well as of the morrision scheme are used.
+!--    Therefore, ztis includes prognostic quantities for qc and nc.
+!--    Technical remark: The switch 'microphysics_morrison' allocates fields of qc and nc and
+!--    enables diagnostic diffusional growth and activation.
        ELSEIF ( cloud_scheme == 'morrison' )  THEN
           microphysics_sat_adjust = .FALSE.
@@ -554,10 +548,9 @@
           microphysics_morrison   = .TRUE.
           precipitation           = .TRUE.
-          microphysics_morrison_no_rain = .FALSE.    
-!          
-!--    The 'morrision_no_rain' scheme includes only processes of morrision scheme
-!--    without the rain processes of seifert beheng. Therfore, the prog. quantities
-!--    of qr and nr remain unallocated. This might be appropiate for cloud in which 
-!--    the size distribution is narrow, e.g. fog. 
+          microphysics_morrison_no_rain = .FALSE.
+!
+!--    The 'morrision_no_rain' scheme includes only processes of morrision scheme without the rain
+!--    processes of seifert beheng. Therfore, the prog. quantities of qr and nr remain unallocated.
+!--    This might be appropiate for cloud in which the size distribution is narrow, e.g. fog.
        ELSEIF ( cloud_scheme == 'morrison_no_rain' )  THEN
           microphysics_sat_adjust = .FALSE.
@@ -568,5 +561,5 @@
           precipitation           = .FALSE.
        ELSE
-          message_string = 'unknown cloud microphysics scheme cloud_scheme ="' // &
+          message_string = 'unknown cloud microphysics scheme cloud_scheme ="' //                  &
                            TRIM( cloud_scheme ) // '"'
           CALL message( 'check_parameters', 'PA0357', 1, 2, 0, 6, 0 )
@@ -582,7 +575,7 @@
           ELSE
              IF ( precipitation_amount_interval > dt_do2d_xy )  THEN
-                WRITE( message_string, * )  'precipitation_amount_interval = ',   &
-                    precipitation_amount_interval, ' must not be larger than ',   &
-                    'dt_do2d_xy = ', dt_do2d_xy
+                WRITE( message_string, * )  'precipitation_amount_interval = ',                    &
+                   precipitation_amount_interval, ' must not be larger than ',                     &
+                   'dt_do2d_xy = ', dt_do2d_xy
                 CALL message( 'check_parameters', 'PA0090', 1, 2, 0, 6, 0 )
              ENDIF
@@ -590,5 +583,5 @@
        ENDIF
 
-       ! TODO: find better sollution for circular dependency problem
+       ! TODO: find better solution for circular dependency problem
        surf_bulk_cloud_model = bulk_cloud_model
        surf_microphysics_morrison = microphysics_morrison
@@ -617,9 +610,9 @@
     END SUBROUTINE bcm_check_parameters
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Check data output for bulk cloud module
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
     SUBROUTINE bcm_check_data_output( var, unit )
 
@@ -633,6 +626,5 @@
           CASE ( 'nc' )
              IF ( .NOT.  microphysics_morrison )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" ' //       &
-                                 'requires ' //                                &
+                message_string = 'output of "' // TRIM( var ) // '" ' // 'requires ' //            &
                                  'cloud_scheme = "morrison"'
                 CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
@@ -642,6 +634,5 @@
           CASE ( 'ni' )
              IF ( .NOT.  microphysics_ice_phase )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" ' //       &
-                                 'requires ' //                                &
+                message_string = 'output of "' // TRIM( var ) // '" ' // 'requires ' //            &
                                  'microphysics_ice_phase = ".TRUE."'
                 CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
@@ -651,6 +642,5 @@
           CASE ( 'nr' )
              IF ( .NOT.  microphysics_seifert )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" ' //       &
-                                 'requires ' //                                &
+                message_string = 'output of "' // TRIM( var ) // '" ' // 'requires ' //            &
                                  'cloud_scheme = "seifert_beheng"'
                 CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
@@ -660,6 +650,5 @@
           CASE ( 'prr' )
              IF ( microphysics_sat_adjust )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" ' //       &
-                                 'is not available for ' //                    &
+                message_string = 'output of "' // TRIM( var ) // '" ' // 'is not available for ' //&
                                  'cloud_scheme = "saturation_adjust"'
                 CALL message( 'check_parameters', 'PA0423', 1, 2, 0, 6, 0 )
@@ -672,6 +661,5 @@
           CASE ( 'qi' )
              IF ( .NOT.  microphysics_ice_phase ) THEN
-                message_string = 'output of "' // TRIM( var ) // '" ' //       &
-                                 'requires ' //                                &
+                message_string = 'output of "' // TRIM( var ) // '" ' // 'requires ' //            &
                                  'microphysics_ice_phase = ".TRUE."'
                 CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
@@ -681,6 +669,5 @@
           CASE ( 'qr' )
              IF ( .NOT.  microphysics_seifert ) THEN
-                message_string = 'output of "' // TRIM( var ) // '" ' //       &
-                                 'requires ' //                                &
+                message_string = 'output of "' // TRIM( var ) // '" ' // 'requires ' //            &
                                  'cloud_scheme = "seifert_beheng"'
                 CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
@@ -689,25 +676,21 @@
 
           CASE ( 'pra*' )
-             IF ( .NOT. microphysics_kessler  .AND.                            &
-                  .NOT. microphysics_seifert )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" ' //       &
-                                 'requires ' //                                &
+             IF ( .NOT. microphysics_kessler  .AND.  .NOT. microphysics_seifert )  THEN
+                message_string = 'output of "' // TRIM( var ) // '" ' // 'requires ' //            &
                                  'cloud_scheme = "kessler" or "seifert_beheng"'
                 CALL message( 'check_parameters', 'PA0112', 1, 2, 0, 6, 0 )
              ENDIF
 ! TODO: find sollution (maybe connected to flow_statistics redesign?)
-!              IF ( j == 1 )  THEN
-!                 message_string = 'temporal averaging of precipitation ' //     &
-!                           'amount "' // TRIM( var ) // '" is not possible'
-!                 CALL message( 'check_parameters', 'PA0113', 1, 2, 0, 6, 0 )
-!              ENDIF
+!             IF ( j == 1 )  THEN
+!                message_string = 'temporal averaging of precipitation ' //                        &
+!                                 'amount "' // TRIM( var ) // '" is not possible'
+!                CALL message( 'check_parameters', 'PA0113', 1, 2, 0, 6, 0 )
+!             ENDIF
              unit = 'mm'
 
           CASE ( 'prr*' )
-             IF ( .NOT. microphysics_kessler  .AND.                            &
-                  .NOT. microphysics_seifert )  THEN
-                message_string = 'output of "' // TRIM( var ) // '"' //        &
-                         ' requires' //                                        &
-                         ' cloud_scheme = "kessler" or "seifert_beheng"'
+             IF ( .NOT. microphysics_kessler  .AND.  .NOT. microphysics_seifert )  THEN
+                message_string = 'output of "' // TRIM( var ) // '"' // ' requires' //             &
+                                 ' cloud_scheme = "kessler" or "seifert_beheng"'
                 CALL message( 'check_parameters', 'PA0112', 1, 2, 0, 6, 0 )
              ENDIF
@@ -723,21 +706,21 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Check data output of profiles for bulk cloud module
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
     SUBROUTINE bcm_check_data_output_pr( variable, var_count, unit, dopr_unit )
 
-       USE arrays_3d,                                                          &
+       USE arrays_3d,                                                                              &
            ONLY: zu
 
-       USE control_parameters,                                                 &
+       USE control_parameters,                                                                     &
            ONLY: data_output_pr
 
-       USE profil_parameter,                                                   &
+       USE profil_parameter,                                                                       &
            ONLY: dopr_index
 
-       USE statistics,                                                         &
+       USE statistics,                                                                             &
            ONLY: hom, statistic_regions
 
@@ -757,8 +740,6 @@
           CASE ( 'nc' )
              IF ( .NOT.  microphysics_morrison )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(var_count) ) //          &
-                                 ' is not implemented for' //                  &
-                                 ' cloud_scheme /= morrison'
+                message_string = 'data_output_pr = ' // TRIM( data_output_pr(var_count) ) //       &
+                                 ' is not implemented for' // ' cloud_scheme /= morrison'
                 CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
              ENDIF
@@ -771,8 +752,6 @@
           CASE ( 'ni' )
              IF ( .NOT.  microphysics_ice_phase )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(var_count) ) //          &
-                                 ' is not implemented for' //                  &
-                                 ' microphysics_ice_phase = ".F."'
+                message_string = 'data_output_pr = ' // TRIM( data_output_pr(var_count) ) //       &
+                                 ' is not implemented for' // ' microphysics_ice_phase = ".F."'
                 CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
              ENDIF
@@ -785,8 +764,6 @@
           CASE ( 'nr' )
              IF ( .NOT.  microphysics_seifert )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(var_count) ) //          &
-                                 ' is not implemented for' //                  &
-                                 ' cloud_scheme /= seifert_beheng'
+                message_string = 'data_output_pr = ' // TRIM( data_output_pr(var_count) ) //       &
+                                 ' is not implemented for' // ' cloud_scheme /= seifert_beheng'
                 CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
              ENDIF
@@ -799,10 +776,8 @@
           CASE ( 'prr' )
              IF ( microphysics_sat_adjust )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(var_count) ) //          &
-                                 ' is not available for' //                    &
-                                 ' cloud_scheme = saturation_adjust'
+                message_string = 'data_output_pr = ' // TRIM( data_output_pr(var_count) ) //       &
+                                 ' is not available for' // ' cloud_scheme = saturation_adjust'
                 CALL message( 'check_parameters', 'PA0422', 1, 2, 0, 6, 0 )
-             ENDIF 
+             ENDIF
              pr_index = 76
              dopr_index(var_count) = pr_index
@@ -820,8 +795,6 @@
           CASE ( 'qi' )
              IF ( .NOT.  microphysics_ice_phase )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(var_count) ) //          &
-                                 ' is not implemented for' //                  &
-                                 ' microphysics_ice_phase = ".F."'
+                message_string = 'data_output_pr = ' //  TRIM( data_output_pr(var_count) ) //      &
+                                 ' is not implemented for' // ' microphysics_ice_phase = ".F."'
                 CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
              ENDIF
@@ -834,8 +807,6 @@
           CASE ( 'qr' )
              IF ( .NOT.  microphysics_seifert )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(var_count) ) //          &
-                                 ' is not implemented for' //                  &
-                                 ' cloud_scheme /= seifert_beheng'
+                message_string = 'data_output_pr = ' // TRIM( data_output_pr(var_count) ) //       &
+                                 ' is not implemented for' // ' cloud_scheme /= seifert_beheng'
                 CALL message( 'check_parameters', 'PA0358', 1, 2, 0, 6, 0 )
              ENDIF
@@ -854,12 +825,12 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Allocate bulk cloud module arrays and define pointers
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
     SUBROUTINE bcm_init_arrays
 
-       USE indices,                                                            &
+       USE indices,                                                                                &
            ONLY:  nxlg, nxrg, nysg, nyng, nzb, nzt
 
@@ -887,9 +858,9 @@
 !
 !--       3D-cloud drop water content, cloud drop concentration arrays
-          ALLOCATE( nc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    nc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    nc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    qc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    qc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
+          ALLOCATE( nc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    nc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    nc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    qc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    qc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
                     qc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
        ENDIF
@@ -898,9 +869,9 @@
 !
 !--       3D-rain water content, rain drop concentration arrays
-          ALLOCATE( nr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    nr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    nr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    qr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    qr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
+          ALLOCATE( nr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    nr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    nr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    qr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    qr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
                     qr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
        ENDIF
@@ -909,9 +880,9 @@
 !
 !--       3D-cloud drop water content, cloud drop concentration arrays
-          ALLOCATE( ni_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    ni_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    ni_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    qi_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
-                    qi_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                       &
+          ALLOCATE( ni_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    ni_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    ni_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    qi_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
+                    qi_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                           &
                     qi_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
        ENDIF
